/*
   =============================================================================
	im700.c -- external declarations
   =============================================================================
*/

#pragma once

#include "asgdsp.h"
#include "fields.h"
#include "instdsp.h"
#include "libdsp.h"
#include "midas.h"
#include "objdefs.h"
#include "score.h"
#include "slice.h"
#include "smdefs.h"
#include "stdint.h"
#include "vsdd.h"
#include "wsdsp.h"

/*
   =============================================================================
	external variables
   =============================================================================
*/

extern	volatile	uint16_t	*asgob;
extern	volatile	uint16_t	*consl;
extern	volatile	uint16_t	*cursl;
extern	volatile	uint16_t	*instob;
extern	volatile	uint16_t	*librob;
extern	volatile	uint16_t	*menuob;
extern	volatile	uint16_t	*nxtsl;
extern	volatile	uint16_t	*obj0;
extern	volatile	uint16_t	*obj1;
extern	volatile	uint16_t	*obj2;
extern	volatile	uint16_t	*obj3;
extern	volatile	uint16_t	*obj4;
extern	volatile	uint16_t	*obj5;
extern	volatile	uint16_t	*obj6;
extern	volatile	uint16_t	*obj7;
extern	volatile	uint16_t	*obj8;
extern	volatile	uint16_t	*obj9;
extern	volatile	uint16_t	*obj10;
extern	volatile	uint16_t	*obj11;
extern	volatile	uint16_t	*obj12;
extern	volatile	uint16_t	*obj13;
extern	volatile	uint16_t	*obj14;
extern	volatile	uint16_t	*obj15;
extern	volatile	uint16_t	*prvsl;
extern	volatile	uint16_t	*saddr;
extern	volatile	uint16_t	*tunob;
extern	volatile	uint16_t	*vtobj;
extern	volatile	uint16_t	*waveob;

extern	int16_t		admctl;
extern	int16_t		adnamsw;
extern	struct	octent	*adoct;
extern	int16_t		aflag;
extern	int16_t		aform;
extern	int16_t		amplval;
extern	int16_t		ancmsw;
extern	int16_t		angroup;
extern	int16_t		anrs[8][16];
extern	int16_t		asgfks;
extern	int16_t		asghit;
extern	int16_t		asgmod;
extern	struct	asgent	asgtab[NASGS];
extern	int16_t		asig;
extern	int16_t		asmode;
extern	int16_t		astat;
extern	int16_t		auxctl;
extern	int16_t		aval;
extern	int16_t		bform;
extern	int16_t		catin;
extern	int16_t		cents;
extern	struct	fet	*cfetp;
extern	int16_t		cflag;
extern	int16_t		chtime;
extern	int16_t		chwait;
extern	int16_t		clkctl;
extern	int16_t		clkrun;
extern	int16_t		clksrc;
extern	int16_t		cmfirst;
extern	int16_t		cmtype;
extern	int16_t		cnote;
extern	int16_t		crate0[];
extern	int16_t		crate1[];
extern	int16_t		crate2[];
extern	struct	selbox	*csbp;
extern	int16_t		ctrsw;
extern	int16_t		curasg;
extern	struct	selbox	*curboxp;
extern	struct	fet	*curfet;
extern	int16_t		curfunc;
extern	int16_t		curgrp;
extern	int16_t		curhold;
extern	int16_t		curinst;
extern	uint16_t	curintp;
extern	int16_t		curmop;
extern	int16_t		curpnt;
extern	int16_t		curpos;
extern	int16_t		cursbox;
extern	int16_t		curscor;
extern	int16_t		cursect;
extern	int16_t		curslim;
extern	int16_t		curtun;
extern	int16_t		curvce;
extern	int16_t		curwave;
extern	int16_t		curwdth;
extern	int16_t		curwfnl;
extern	int16_t		curwhrm;
extern	int16_t		curwhrv;
extern	int16_t		curwoff;
extern	int16_t		curwpnt;
extern	int16_t		curwslt;
extern	int16_t		cvtime;
extern	int16_t		cvwait;
extern	int16_t		cxrate;
extern	int16_t		cxval;
extern	int16_t		cyrate;
extern	int16_t		cyval;
extern	int16_t		debugne;
extern	int16_t		debugsw;
extern	int16_t		defect;
extern	uint16_t	dfbuf[4096];
extern	int16_t		dferror;
extern	int16_t		dfsides;
extern	int16_t		dftype;
extern	int16_t		dsp_ok;
extern	int16_t		dubsw;
extern	int16_t		ebflag;
extern	int16_t		editss;
extern	int16_t		editsw;
extern	int16_t		endflg;
extern	int16_t		ext_cv1;
extern	int16_t		ext_cv2;
extern	int16_t		ext_cv3;
extern	int16_t		ext_cv4;
extern	int16_t		ext_mod;
extern	struct	fcat	filecat[FCMAX];
extern	struct	gdsel	*gdfsep;
extern	struct	gdsel	gdfsl[MAXFSL];
extern	struct	gdsel	*gdstbc[NGDSEL];
extern	struct	gdsel	*gdstbn[NGDSEL];
extern	struct	gdsel	*gdstbp[NGDSEL];
extern	int16_t		gomode;
extern	int16_t		grp2prt[12][2];
extern	int16_t		grptran;
extern	int16_t		gtmsel;
extern	int16_t		hcwval;
extern	int16_t		hitbox;
extern	int16_t		hitcx;
extern	int16_t		hitcy;
extern	struct	s_entry	*hplist[N_SCORES][N_TYPES];
extern	int16_t		idcfsw;
extern	struct	instdef	idefs[NINST];
extern	int16_t		idimsw;
extern	int16_t		idintmp;
extern	int16_t		idnamsw;
extern	struct	octent	*idoct;
extern	int16_t		idsrcsw;
extern	int16_t		idtdat;
extern	int16_t		imflag;
extern	struct	fet	*infetp;
extern	int16_t		initcfg;
extern	int16_t		insmode;
extern	int16_t		ismode;
extern	int16_t		lampio;
extern	int16_t		lampsw;
extern	int16_t		lasgsw;
extern	int16_t		lastam;
extern	int16_t		ldelsw;
extern	int16_t		lderrsw;
extern	struct	mlibhdr	ldhead;
extern	int16_t		ldidsiz;
extern	int16_t		ldkind;
extern	struct	octent	*ldoct;
extern	int16_t		ldpass;
extern	int16_t		ldrow;
extern	int16_t		ldslot;
extern	int16_t		legato;
extern	struct	s_entry	*libsp;
extern	int16_t		lksel;
extern	int16_t		lmwtype;
extern	int16_t		loadrow;
extern	int16_t		loadsw;
extern	int16_t		loctab[9];
extern	int16_t		lorchl;
extern	int16_t		lorchsw;
extern	int16_t		lorclsw;
extern	int16_t		lpatsw;
extern	int16_t		lrasw;
extern	int16_t		lscrsw;
extern	int16_t		lselsw;
extern	int16_t		lseqsw;
extern	int16_t		lstbgnc;
extern	struct	n_entry	*lstbgns[NLSTENTS];
extern	int16_t		lstendc;
extern	struct	n_entry	*lstends[NLSTENTS];
extern	int16_t		lstflag;
extern	int16_t		lstrsw;
extern	int16_t		lstwoff;
extern	int16_t		lstwpnt;
extern	int16_t		ltagged;
extern	int16_t		ltunsw;
extern	int16_t		lwavsw;
extern	int16_t		mascntr;
extern	int16_t		mdb1;
extern	int16_t		mdb2;
extern	struct	octent	*mdoct;
extern	int16_t		michan;
extern	int16_t		midiclk;
extern	int16_t		midigo;
extern	int16_t		mistat;
extern	struct	EXFILE	mphead;
extern	int16_t		nchwait;
extern	int16_t		ncvwait;
extern	int16_t		ndisp;
extern	struct	nevent	*nefree;
extern	struct	nevent	*nelist;
extern	struct	nevent	nevents[NNEVTS];
extern	int16_t		newflag;
extern	int16_t		nkdown;
extern	int16_t		notenum;
extern	int16_t		noteop;
extern	int16_t		notepit;
extern	int16_t		notesel;
extern	int16_t		npts;
extern	int16_t		nxtflag;
extern	int8_t		oldltag;
extern	int16_t		oldpk;
extern	int16_t		oldsl;
extern	struct	s_entry	*p_bak;
extern	struct	s_entry	*p_cbgn;
extern	struct	s_entry	*p_cend;
extern	struct	s_entry	*p_ctr;
extern	struct	s_entry	*p_cur;
extern	struct	s_entry	*p_fwd;
extern	struct	n_entry	*p_nbeg;
extern	struct	n_entry	*p_nend;
extern	struct	s_entry	*p_sbgn;
extern	struct	s_entry	*p_sec1;
extern	struct	s_entry	*p_sec2;
extern	struct	s_entry	*p_send;
extern	int16_t		pchsw;
extern	int16_t		pecase;
extern	struct	s_entry	*peg;
extern	struct	pflent	pfents[NPFENTS];
extern	struct	pflent	*pflist;
extern	struct	pflent	*pfqhdr;
extern	int16_t		pkctrl;
extern	struct	instpnt	*pntptr;
extern	int16_t		pntsv;
extern	int16_t		prgchan;
extern	int16_t		ps_dpth;
extern	int16_t		ps_intn;
extern	int16_t		ps_rate;
extern	int16_t		pulsclk;
extern	int16_t		recsw;
extern	int16_t		runit;
extern	int16_t		sbase;
extern	int16_t		scmctl;
extern	struct	s_entry	*scores[N_SCORES];
extern	struct	s_entry	*scp;
extern	uint16_t	scrl;
extern	int16_t		scrlpot;
extern	int16_t		sctctab[10][64];
extern	int16_t		sd;
extern	int16_t		sdmcol;
extern	int16_t		sdmctl;
extern	int16_t		sdmrow;
extern	int16_t		se;
extern	struct	s_entry	*seclist[N_SCORES][N_SECTS];
extern	int16_t		secop;
extern	int16_t		secopok;
extern	int16_t		sgcsw;
extern	int16_t		sgoflag;
extern	int16_t		sharp;
extern	int16_t		sigtab[128][2];
extern	struct	scndx	sindex[N_SCORES];
extern	struct	s_entry	*size1;
extern	struct	s_entry	*size2;
extern	struct	s_entry	*size3;
extern	uint16_t	slices[896];
extern	int16_t		sliders;
extern	struct	sment	sments[192];
extern	int16_t		soffset;
extern	int16_t		ss_ptsw;
extern	int16_t		ss_sqsw;
extern	int16_t		stccol;
extern	int16_t		stcrow;
extern	int16_t		stepclk;
extern	int16_t		stepenb;
extern	int16_t		stepint;
extern	int16_t		stepwgt;
extern	struct	s_time	stimes[N_SCORES][N_SECTS];
extern	int16_t		subj;
extern	int16_t		submenu;
extern	int16_t		swback;
extern	int16_t		swctrl;
extern	int16_t		swdelta;
extern	int16_t		swdir;
extern	int16_t		swfiin;
extern	int16_t		swflag;
extern	int16_t		swlast;
extern	int16_t		swndx;
extern	int16_t		swstop;
extern	int16_t		swthr;
extern	int16_t		swtime;
extern	int16_t		swwait;
extern	int16_t		tagslot;
extern	int16_t		tdnamsw;
extern	struct	octent	*tdoct;
extern	uint16_t	temax;
extern	uint16_t	temin;
extern	int16_t		testing;
extern	int16_t		tglclk;
extern	int16_t		tglpch;
extern	int16_t		thcwval;
extern	int16_t		thescore;
extern	uint16_t	timemlt;
extern	int16_t		tkback;
extern	int16_t		tkctrl;
extern	int16_t		tkrmin;
extern	int16_t		tkthr;
extern	int16_t		tktime;
extern	int16_t		tkwait;
extern	int16_t		tmpomlt;
extern	int16_t		tmpoval;
extern	uint16_t	tmultab[];
extern	int16_t		trkball;
extern	int16_t		ttcmdsv;
extern	int16_t		ttsel1;
extern	int16_t		ttsel2;
extern	int16_t		ttsel3;
extern	int16_t		tuneval;
extern	int16_t		tunlib[NTUNS][128];
extern	int16_t		tunmod;
extern	int16_t		tunval;
extern	int16_t		tvcwval;
extern	int16_t		txfiin;
extern	int16_t		txflag;
extern	int16_t		txlast;
extern	int16_t		txstop;
extern	int16_t		tyfiin;
extern	int16_t		tyflag;
extern	int16_t		tylast;
extern	int16_t		tystop;
extern	struct	valent	valents[NGPSRS];
extern	int16_t		varmode[8][16];
extern	struct	instdef	vbufs[12];
extern	int16_t		vcwval;
extern	int16_t		velflag;
extern	int16_t		verbose;
extern	int16_t		vlbtype;
extern	struct	sment	*vpsms[192];
extern	int16_t		vrbw08;
extern	int16_t		vrbw09;
extern	int16_t		vrbw10;
extern	int16_t		vrbw11;
extern	int16_t		vrbw12;
extern	int16_t		vrbw13;
extern	int16_t		vrbw14;
extern	int16_t		vrbw15;
extern	int16_t		vrcw;
extern	uint16_t	vtbgval;
extern	int16_t		vtccol;
extern	int16_t		vtcrow;
extern	int8_t		vtdechr;
extern	int16_t		vtdecol;
extern	uint16_t	vtfgval;
extern	int16_t		vtpcol;
extern	int16_t		vtprow;
extern	int16_t		vtwcol;
extern	int16_t		vtwrow;
extern	int16_t		vtxval;
extern	int16_t		vtyval;
extern	int16_t		wcflag;
extern	int16_t		wcmcol;
extern	int16_t		wcmrow;
extern	int16_t		wcpage;
extern	struct	octent	*wdoct;
extern	int16_t		wdupdfl;
extern	int16_t		wmcsel;
extern	int16_t		wmctag;
extern	int16_t		wplast;
extern	int16_t		wpntsv;
extern	int16_t		wshmax;
extern	struct	wstbl	wslib[NUMWAVS];
extern	int16_t		wsnmod[12][2];
extern	int16_t		wvlast;
extern	int16_t		xkcount;
extern	int16_t		xkstat;
extern	int16_t		xycntr;
extern	int16_t		ykcount;
extern	int16_t		ykstat;

/*
   =============================================================================
	external functions
   =============================================================================
*/

extern	void		clrpfl(void);
extern	void		im700(void);
extern	void		inismtb(void);
extern	int16_t		valof(int16_t srcv);
